<?php class controller_component_faq extends component {
	protected $errors = array();
	protected $limit = 10;
	function action_index(){
		$this->page['head'] .= $this->add_css_file(SITE_URL . '/modules/components/' . $this->component_name . '/back_end/views/faq.css');
		$this->page['title'] = 'Вопросы и ответы';
		//получаем количество вопросов
		$this->data['all'] = $this->model->count_questions();
		//удаление вопроса
		if(isset($_GET['delete'])){
			$url = $this->url['request_uri'];
			$this->data['delete'] = $this->model->delete_question($_GET['delete']);
			header("refresh:2; url=$url");
		}
		//base_url для пагинации(третий параметр)
		if (count($this->url['actions']) == 1 && $this->url['actions'][0] == 'index') {;
            $this->data['base_url'] = SITE_URL . '/admin/' . $this->url['component'];
        } else {
            $this->data['base_url'] = SITE_URL . '/admin/' . $this->url['component'] . '/' . implode('/', $this->url['actions']);
        }

		if($this->data['all'][0] == 0){
			$this->page['html'] = 'Вопросов пока нет';
		} else{
			//начало десятки вопросов
			$this->data['start'] = isset($this->url['params']['page']) ? ($this->url['params']['page']-1)*$this->limit : 0;
			//десятка вопросов
			$this->data['item'] = $this->model->get_questions($this->data['start'], $this->limit);
			//количество страниц пагинации(второй параметр)
			$this->data['number_of_pages'] = ceil($this->data['all'][0]/$this->limit);
			//текущая страница пагинации (первый параметр)
			$this->data['current_page'] = isset($this->url['params']['page']) ? intval($this->url['params']['page']) : 0;
        	if ($this->data['current_page'] > $this->data['number_of_pages']){
        		$this->data['current_page'] = $this->data['number_of_pages'];
        	}
        		elseif ($this->data['current_page'] < 1){
        			$this->data['current_page'] = 1;
        		}
			$this->page['html'] = $this->load_view();
		}
		// core::print_r($this);
		return $this->page;
	}

	function action_answer(){
		$this->page['title'] = 'Ответить';
		//id вопроса получаем из ссылки во виюхе
		$this->data['id'] = intval($this->url['actions'][1]);
		//вопрос по id
		$this->data['item'] = $this->model->get_question($this->data['id']);
		//ссылка для кнопки назад
		$this->data['back_url'] = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : SITE_URL . '/admin/' . $this->url['component'];

		if (isset($_POST['answer']) && empty($_POST['answer_text'])){
			$this->errors[] = 'Введите ответ';
		}
		//передаем сообщения об ошибке виюхе
		$this->data['errors'] = $this->errors;
		// core::print_r($this);
		//записываем ответ в БД если ошибок нет
		if (isset($_POST['answer']) && count($this->errors) == 0){
			$this->model->set_answer(strip_tags($_POST['answer_text']), $this->data['id']);
		}
		//если запрос в БД  вернул ошибку передаем страницу ошибки
		if ($this->data['item']){
		$this->page['html'] = $this->load_view('answer');
		} else{
			$this->page['title'] = 'Ошибка 404: страница не найдена';
			$this->page['html'] = $this->load_view('404_not_found');
			}
		return $this->page;
	}

	function action_change(){
		$this->page['title'] = 'Изменить ответ';
		$this->data['id'] = intval($this->url['actions'][1]);
		$this->data['item'] = $this->model->get_question($this->data['id']);
		$this->data['url'] = $this->url['actions']['1'];
		if(isset($_SERVER['HTTP_REFERER'])){
			$this->data['back_url'] = $_SERVER['HTTP_REFERER'];
		} else if(isset($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER'] == SITE_URL . $this->url['request_uri']){
			$this->data['back_url'] = SITE_URL . '/admin/' . $this->component_name;
			} else{
				$this->data['back_url'] = SITE_URL . 'admin' . $this->component_name;
			}	
		// core::print_r($this);
		//анологично answer и записываем изменения в БД если таковые есть 
		if (isset($_POST['change_answer']) && count($this->errors) == 0 && $_POST['answer_changed_text'] != $this->data['item'][0]['answer']){
			$this->model->set_answer(strip_tags($_POST['answer_changed_text']), $this->data['id']);
		} else {
			$this->data['errors'] = $this->errors;
		}
		if (!empty($this->data['item'][0]) && $this->data['item']){
		$this->page['html'] = $this->load_view('change');
		} else{
			$this->page['title'] = 'Ошибка 404: страница не найдена';
			$this->page['html'] = $this->load_view('404_not_found');
			}
		return $this->page;
	}
	function action_activate(){
	$this->model->create_table_questions();
	}
	function action_else() {
		$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a>&#8594;Ошибка 404';		
		$this->page['title'] = 'Ошибка 404: страница не найдена';
		return $this->action_404('404_not_found');
	}

} 