<?php class controller_component_faq extends component {
	protected $limit = 10; //сколко вопросов будет в списке на одной странице
	protected $errors = array(); //массив для сохранения ошибок при передаче данных в БД
	protected $captcha_suffix = '_faq';//используется капча движка
	function action_index() {
		$this->page['title'] = 'Вопросы и ответы';
		$this->data['breadcrumbs'] = array(
            'labels' => array('Главная', $this->component_info['name']),
            'hrefs' => array(SITE_URL, SITE_URL . '/' . $this->url['component'])
        );
        if (file_exists($this->view_dir . '/faq.css')) {
			$css = SITE_URL . '/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		} else {
			$css = SITE_URL . '/user_cms/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		}
		// $this->page['head'] .= $this->add_css_file($css);
		//начало десятки вопросов
		$this->data['start'] = isset($this->url['params']['page']) ? intval(($this->url['params']['page']-1)*$this->limit) : 0;
		//десятка вопросов
		$this->data['item'] = $this->model->get_questions($this->data['start'], $this->limit);
		//получаем общее количество вопросов
		$this->data['all'] = $this->model->count_questions();
		//количество страниц, текущая страница и base_url для пагинации
		$this->data['number_of_pages'] = ceil($this->data['all'][0]/$this->limit);
		$this->data['current_page'] = isset($this->url['params']['page']) ? intval($this->url['params']['page']) : 0;
        	if ($this->data['current_page'] > $this->data['number_of_pages']){
        		$this->data['current_page'] = $this->data['number_of_pages'];
        	}
        		elseif ($this->data['current_page'] < 1){
        		 $this->data['current_page'] = 1;
        		}
        if (count($this->url['actions']) == 1 && $this->url['actions'][0] == 'index') {;
            $this->data['base_url'] = SITE_URL . '/' . $this->url['component'];
        } else {
            $this->data['base_url'] = SITE_URL . '/' . $this->url['component'] . '/' . implode('/', $this->url['actions']);
        }
		if($this->data['item']){
			$this->page['html'] = $this->load_view();
		}
			else{
	        	$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a>&#8594;Ошибка 404';
				$this->page['title'] = 'Ошибка 404: страница не найдена';
				$this->page['html'] = $this->load_view('404_not_found');
			}
		
		// core::print_r($this);
		// core::print_r($this->url);
		return $this->page;
	}
	function action_ask(){
		$this->page['title'] = 'Задать вопрос';
		if (file_exists($this->view_dir . '/faq.css')) {
			$css = SITE_URL . '/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		} else {
			$css = SITE_URL . '/user_cms/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		}
		$this->page['head'] .= $this->add_css_file($css);
		$this->data['breadcrumbs'] = array(
            'labels' => array('Главная', $this->component_info['name'], $this->page['title']),
            'hrefs' => array(SITE_URL, SITE_URL.'/'.$this->url['component'], SITE_URL.'/'.$this->url['component'].'/'.$this->url['actions'][0])
        );
        //капча - капча движка
        $captcha_suffix = '_faq';
		$this->data['captcha'] = true;
		$this->data['src_captcha'] = SITE_URL . '/user_cms/helpers/captcha.php?suffix=' . $captcha_suffix;
				if ((!isset($_SESSION['captcha' . $captcha_suffix]) || !isset($_POST['captcha']) || empty($_POST['captcha']) || $_SESSION['captcha' . $captcha_suffix] !== $_POST['captcha'])) {
		$this->errors[] = 'Неверные символы';
		}
		//Если есть ошибки переносим в массив errors
		if(isset($_POST['send'])){
			if(empty($_POST['email']) OR empty($_POST['question_text'])){
				$this->errors[] = 'Нужно заполнить все поля';
			}
			if(preg_match('/(\w+@[a-zA-Z_]+?\.[a-zA-Z]{2,16})/', $_POST['email']) == 0){
				$this->errors[] = 'Неверный формат email адреса';
			}
		}
		//перенос ошибок во виюху
		$this->data['errors'] = $this->errors;
		//если ошибок нет записываем данные в БД
		if(isset($_POST['send']) && count($this->errors) == 0){
			$this->model->insert_question(strip_tags($_POST['question_text']), date('Y-m-d'), trim(strip_tags($_POST['email'])));
		}
		// core::print_r($this);
		// core::print_r($this->url);
		$this->page['html'] = $this->load_view('ask');
		return $this->page;
	}
	function action_question(){
		//ссылка кнопки назад
		if(isset($_SERVER['HTTP_REFERER'])){
			$this->data['back_url'] = $_SERVER['HTTP_REFERER'];
		} else if(isset($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER'] == SITE_URL . $this->url['request_uri']){
			$this->data['back_url'] = SITE_URL . $this->component_name;
			} else{
				$this->data['back_url'] = SITE_URL . $this->component_name;
			}
		//id вопроса передается из адресной строки
		$this->data['id'] = isset($this->url['actions'][1]) ? intval($this->url['actions'][1]) : 0;
		$this->page['title'] = 'Вопрос N' . $this->data['id'];
		if (file_exists($this->view_dir . '/faq.css')) {
			$css = SITE_URL . '/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		} else {
			$css = SITE_URL . '/user_cms/modules/components/' . $this->component_name . '/front_end/views/faq.css';
		}
		$this->page['head'] .= $this->add_css_file($css);
		//Хлебные крошки
		$this->data['breadcrumbs'] = array(
            'labels' => array('Главная', $this->component_info['name'], $this->page['title']),
            'hrefs' => array(SITE_URL, SITE_URL . '/' . $this->url['component'], '#')
        );	
        //получаем вопрос	
		$this->data['item'] = $this->model->get_question($this->data['id']); 
		//если запрос вернул ошибку загружаем страницу 404 ошибки 
		if($this->data['item']){
			$this->page['html'] = $this->load_view('question');
		} 
			else{
				$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a>&#8594;Ошибка 404';		
				$this->page['title'] = 'Ошибка 404: страница не найдена';
				$this->page['html'] = $this->load_view('404_not_found');
			}
		// core::print_r($this);
/*		echo'<pre>';
		print_r($_SERVER);
		echo'</pre>';*/
		// core::print_r($this->url);
		return $this->page;
	}
	function action_else() { // ошибка 404 страница не найдена
		$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a>&#8594;Ошибка 404';		
		$this->page['title'] = 'Ошибка 404: страница не найдена';
		return $this->action_404('404_not_found');
	}
} 
?>